// Code generated by gobind. DO NOT EDIT.

// Java class im.igroup.GroupManager is a proxy for talking to a Go program.
//
//   autogenerated by gobind -lang=java -javapkg=im imsdk/im/igroup
package im.igroup;

import go.Seq;

/**
 * GroupManager 群组管理器定义
 */
public final class GroupManager implements Seq.Proxy {
	static { Igroup.touch(); }
	
	private final int refnum;
	
	@Override public final int incRefnum() {
	      Seq.incGoRef(refnum, this);
	      return refnum;
	}
	
	// skipped constructor GroupManager.NewGroupManager with unsupported parameter or return types
	
	GroupManager(int refnum) { this.refnum = refnum; Seq.trackGoRef(refnum, this); }
	
	/**
	 * AddMembers 添加群成员
	param userIds 用户 ID 列表
	结果通过 onDone 回调反馈；result.Group 总是为 nil
	 */
	public native void addMembers(String groupID, im.helper.Strings userIds, OnResult onDone);
	/**
	 * ChangeAvatar 更换群头像
	 */
	public native void changeAvatar(String groupID, String imgPath, im.evt.OnDone onDone);
	/**
	 * ChangeDesc 修改群描述
	 */
	public native void changeDesc(String groupID, String desc, im.evt.OnDone onDone);
	/**
	 * ChangeName 修改群名
	 */
	public native void changeName(String groupID, String name, im.evt.OnDone onDone);
	/**
	 * ChangeOwner 转让群主
	结果通过 onDone 回调反馈
	 */
	public native void changeOwner(String groupID, String newOwner, im.evt.OnDone onDone);
	/**
	 * CreateGroup 创建包含指定成员的群组
	结果通过 onDone 回调反馈
	如果后续操作触发群组信息变更，SDK 可能会对回调返回的群组对象做更新
	 */
	public native void createGroup(im.helper.Strings userIds, OnResult onDone);
	/**
	 * DelFromCache for internal use only
	 */
	public native void delFromCache(String groupID);
	/**
	 * FindLocalGroupMembers finds group members with the name matching keyword locally.
	param keyword: 返回名称包含keyword的群成员，如果keyword为空则返回所有群成员
	 */
	public native GroupMemberList findLocalGroupMembers(String groupID, String keyword);
	/**
	 * FindLocalGroups finds groups with the name matching keyword locally.
	param keyword: 返回名称包含keyword的群，如果keyword为空则返回所有群组
	 */
	public native GroupList findLocalGroups(String keyword);
	/**
	 * HandleJoinRequests 处理入群申请
	param reqIds: 待处理的入群申请的 ID 列表
	param acceptOrDeny: true-批准入群；false-拒绝入群
	结果通过 onDone 回调反馈
	 */
	public native void handleJoinRequests(im.helper.Strings reqIds, boolean acceptOrDeny, im.evt.OnDone onDone);
	/**
	 * HandleJoinRequestsInGroup 批准/拒绝某群组的所有未处理入群申请
	param groupId: 群 ID
	param acceptOrDeny: true-批准入群；false-拒绝入群
	结果通过 onDone 回调反馈
	 */
	public native void handleJoinRequestsInGroup(String groupID, boolean acceptOrDeny, im.evt.OnDone onDone);
	// skipped method GroupManager.Init with unsupported parameter or return types
	
	/**
	 * Join 加入指定群组
	param typ: 取值为 invite 或 qrcode
	param inviter: 邀请人。当 typ 为 qrcode 时，可为空
	结果通过 onDone 回调反馈
	 */
	public native void join(String groupID, String inviter, String typ, im.evt.OnDone onDone);
	// skipped method GroupManager.LoadChatter with unsupported parameter or return types
	
	/**
	 * LoadGroup 加载群组详情
	结果通过 onDone 回调反馈
	优先返回本地存储的信息，同时会去服务器拉取最新信息，如果有变更，会通过 onUpdate 回调通知
	如果 forceRefresh 为 true，则先尝试从服务器拉取，如果失败则从本地加载
	如果群组信息有更新，SDK 可能会对回调返回的对象做更新
	 */
	public native void loadGroup(String groupID, boolean forceRefresh, OnGroupDone onDone, OnGroupUpdate onUpdate);
	/**
	 * LoadGroupMembers 加载成员列表.
	param roles: 成员角色：GroupRoleMember/GroupRoleAdmin/GroupRoleOwner 或它们的组合；0 表示全部成员
	param order: 成员排序方式：OrderByName/OrderByTime/NoOrder
	param limit: 限制返回的成员数量; 0 代表不限制
	如果 forceRefresh 为 true，则先尝试从服务器拉取，如果失败则从本地加载
	结果通过 onDone 回调反馈；如果随后的拉取发现有变更，会通过 onUpdate 回调通知
	 */
	public native void loadGroupMembers(String groupID, long roles, long order, long limit, boolean forceRefresh, OnGroupMembersDone onDone, OnGroupMembersUpdate onUpdate);
	// skipped method GroupManager.LoadGroupSynced with unsupported parameter or return types
	
	/**
	 * LoadGroups 加载群组列表，列表按群组名排序
	结果通过 onDone 回调反馈；如果随后的拉取发现有变更，会通过 onUpdate 回调通知
	如果群组列表已经加过，则不会重新从服务器加载。此时可以将 forceRefresh 设为 true 强制从服务器加载
	 */
	public native void loadGroups(boolean forceRefresh, OnGroupsDone onDone, OnGroupsUpdate onUpdate);
	/**
	 * LoadJoinRequests 加载入群申请列表
	param groupId: 获取该群的加入申请
	param includeReqId: 保证这个加群申请出现在结果中如果它还未被处理的话
	param pageSize, pageNum: 分页参数。pageNum 从 1 开始； pageSize 最大 100，默认 20。
	结果通过 onDone 回调反馈
	 */
	public native void loadJoinRequests(String groupID, String includeReqID, long pageSize, long pageNum, OnJoinRequestsDone onDone);
	/**
	 * LoadLocalGroup 从本地数据库加载群组，如果不存在，则返回 nil。
	返回的群组的某些信息有可能不准确（因为没有拉取过群组详情或没有及时更新）。
	 */
	public native Group loadLocalGroup(String groupID);
	/**
	 * LoadMemberRole 获取某人是否是群成员，如果是，则返回在群内的角色: consts.GroupRoleX
	 */
	public native void loadMemberRole(String groupID, String userID, im.evt.OnDoneWithInteger onDone);
	/**
	 * ManageAdmins 添加删除群管理员
	增加管理员时，指定的 userId 必须是该群的成员；删除管理员时，被删除的管理员将变为该群的普通成员
	param addOrDel true: 进行添加操作；false: 进行删除操作
	param userIds 用户 ID 列表
	结果通过 onDone 回调反馈
	 */
	public native void manageAdmins(String groupID, boolean addOrDel, im.helper.Strings userIds, im.evt.OnDone onDone);
	/**
	 * ManageMembers 管理群成员（已过时，请使用 AddMembers/RemoveMembers/ManageAdmins）
	增加管理员时，指定的 userId 必须是该群的成员；删除管理员时，被删除的管理员将变为该群的普通成员
	param addOrDel true: 进行添加操作；false: 进行删除操作
	param adminsOrMembers true: 对管理员列表进行操作；false: 对成员列表进行操作
	param userIds 用户 ID 列表
	结果通过 onDone 回调反馈
	 */
	public native void manageMembers(String groupID, boolean addOrDel, boolean adminsOrMembers, im.helper.Strings userIds, im.evt.OnDone onDone);
	// skipped method GroupManager.OnGroupEvent with unsupported parameter or return types
	
	// skipped method GroupManager.OnGroupJoinRequest with unsupported parameter or return types
	
	// skipped method GroupManager.OnGroupUpdate with unsupported parameter or return types
	
	/**
	 * Quit 退出指定群组
	结果通过 onDone 回调反馈
	 */
	public native void quit(String groupID, im.evt.OnDone onDone);
	/**
	 * RegGroupEventListener 注册群组事件监听器
	 */
	public native void regGroupEventListener(OnGroupEvent listener);
	/**
	 * RemoveMembers 移除群成员
	param userIds 用户 ID 列表
	结果通过 onDone 回调反馈
	 */
	public native void removeMembers(String groupID, im.helper.Strings userIds, im.evt.OnDone onDone);
	/**
	 * SetJoinConfirm 切换入群许可设置
	 */
	public native void setJoinConfirm(String groupID, boolean v, im.evt.OnDone onDone);
	/**
	 * SetMuted 切换免打扰设置
	 */
	public native void setMuted(String groupID, boolean v, im.evt.OnDone onDone);
	/**
	 * SetPublicity 切换群隐私性
	 */
	public native void setPublicity(String groupID, boolean v, im.evt.OnDone onDone);
	/**
	 * SetTopped 切换会话置顶设置
	 */
	public native void setTopped(String groupID, boolean v, im.evt.OnDone onDone);
	// skipped method GroupManager.SetUpdateEvtListener with unsupported parameter or return types
	
	/**
	 * UnregGroupEventListener 移除群组事件监听器
	 */
	public native void unregGroupEventListener(OnGroupEvent listener);
	@Override public boolean equals(Object o) {
		if (o == null || !(o instanceof GroupManager)) {
		    return false;
		}
		GroupManager that = (GroupManager)o;
		return true;
	}
	
	@Override public int hashCode() {
	    return java.util.Arrays.hashCode(new Object[] {});
	}
	
	@Override public String toString() {
		StringBuilder b = new StringBuilder();
		b.append("GroupManager").append("{");
		return b.append("}").toString();
	}
}

