// Code generated by gobind. DO NOT EDIT.

// Java class im.iuser.UserManager is a proxy for talking to a Go program.
//
//   autogenerated by gobind -lang=java -javapkg=im imsdk/im/iuser
package im.iuser;

import go.Seq;

/**
 * UserManager 用户管理器定义
 */
public final class UserManager implements Seq.Proxy {
	static { Iuser.touch(); }
	
	private final int refnum;
	
	@Override public final int incRefnum() {
	      Seq.incGoRef(refnum, this);
	      return refnum;
	}
	
	// skipped constructor UserManager.NewUserManager with unsupported parameter or return types
	
	UserManager(int refnum) { this.refnum = refnum; Seq.trackGoRef(refnum, this); }
	
	/**
	 * ChangeAlias 修改备注
	 */
	public native void changeAlias(String userID, String alias, im.evt.OnDone onDone);
	/**
	 * DelFromCache for internal use only
	 */
	public native void delFromCache(String userID);
	/**
	 * FindLocalFriends finds users with the name/nickname/alias matching keyword in local contacts.
	param typ: 指定好友列表的类别：UserTypeBot/UserTypeMan/0(all)
	param keyword: 返回name/nickname/alias之一包含keyword的人，如果keyword为空则返回所有联系人
	 */
	public native UserList findLocalFriends(long typ, String keyword);
	/**
	 * FindUser 从全体用户中查找符合条件的用户
	结果通过 onDone 回调反馈
	 */
	public native void findUser(String keyword, OnFindUser onDone);
	/**
	 * Follow 将指定用户加到好友列表里
	结果通过 onDone 回调反馈
	 */
	public native void follow(String userID, im.evt.OnDone onDone);
	// skipped method UserManager.Init with unsupported parameter or return types
	
	/**
	 * IsFollowing 判断指定用户是否在好友列表里
	 */
	public native boolean isFollowing(String userID);
	/**
	 * IsLoaded 好友列表是否加载完成
	 */
	public native boolean isLoaded();
	// skipped method UserManager.LoadChatter with unsupported parameter or return types
	
	/**
	 * LoadFriends 加载好友列表，列表按好友显示名排序
	param typ: 指定好友列表的类别：UserTypeBot/UserTypeMan/0(all)
	结果通过 onDone 回调反馈；如果随后的拉取发现有变更，会通过 onUpdate 回调通知
	如果好友列表已经加过，则不会重新从服务器加载。此时可以将 forceRefresh 设为 true 强制从服务器加载
	 */
	public native void loadFriends(long typ, boolean forceRefresh, OnUsersDone onDone, OnUsersUpdate onUpdate);
	/**
	 * LoadFriendsNotInGroup 从联系人列表里查找那些不在指定群里的人员
	 */
	public native void loadFriendsNotInGroup(String groupID, OnUsersDone onDone);
	/**
	 * LoadLocalUser 从本地数据库加载指定用户，如果不存在，则返回 nil。
	返回的用户的某些信息有可能不准确（因为没有拉取过用户详情或没有及时更新）。
	 */
	public native User loadLocalUser(String userID);
	/**
	 * LoadUser 加载用户或服务号详情
	结果通过 onDone 回调反馈
	优先返回本地存储的信息，同时会去服务器拉取最新信息，如果有变更，会通过 onUpdate 回调通知
	如果 forceRefresh 为 true，则先尝试从服务器拉取，如果失败则从本地加载
	如果用户信息有更新，SDK 可能会对回调返回的用户对象做更新
	 */
	public native void loadUser(String userID, boolean forceRefresh, OnUserDone onDone, OnUserUpdate onUpdate);
	// skipped method UserManager.LoadUserSynced with unsupported parameter or return types
	
	/**
	 * ReportUser 举报用户
	param reason: 举报因由分类
	param desc: 举报事项的详细描述
	param pics: 图片路径列表
	 */
	public native void reportUser(String userID, String reason, String desc, im.helper.Strings pics, im.evt.OnDone onDone);
	/**
	 * SetBlocked 切换屏蔽消息设置
	 */
	public native void setBlocked(String userID, boolean v, im.evt.OnDone onDone);
	/**
	 * SetMuted 切换免打扰设置
	 */
	public native void setMuted(String userID, boolean v, im.evt.OnDone onDone);
	/**
	 * SetTopped 切换会话置顶设置
	 */
	public native void setTopped(String userID, boolean v, im.evt.OnDone onDone);
	// skipped method UserManager.SetUpdateEvtListener with unsupported parameter or return types
	
	/**
	 * Unfollow 从好友列表里删除指定用户
	结果通过 onDone 回调反馈
	 */
	public native void unfollow(String userID, im.evt.OnDone onDone);
	/**
	 * UpdateBotsName 更新 bot 的名称
	 */
	public native void updateBotsName(im.evt.OnDone onDone);
	/**
	 * UploadPhonebookMd5 上传通讯录自动关注匹配的用户
	param md5s: 联系人电话号码 MD5 列表
	param names: 联系人姓名列表，应与 md5s 列表一一对应
	 */
	public native void uploadPhonebookMd5(im.helper.Strings md5s, im.helper.Strings names, im.evt.OnDone onDone);
	@Override public boolean equals(Object o) {
		if (o == null || !(o instanceof UserManager)) {
		    return false;
		}
		UserManager that = (UserManager)o;
		return true;
	}
	
	@Override public int hashCode() {
	    return java.util.Arrays.hashCode(new Object[] {});
	}
	
	@Override public String toString() {
		StringBuilder b = new StringBuilder();
		b.append("UserManager").append("{");
		return b.append("}").toString();
	}
}

